; 

    .686p                     ; maximum processor model
    .model flat, stdcall      ; memory model & calling convention
    option casemap :none      ; case sensitive

    include cpuid.inc

    .code       ; code section

; 

get_x86_instruction_sets proc pStruct:DWORD

  ; mov eax, 80000001h

  ; bit 20 ecx = sse4.2     intel
  ; bit 19 ecx = sse4.1     intel
  ; bit  0 ecx = sse3       intel   + amd
  ; bit 26 edx = sse2       intel   + amd
  ; bit 25 edx = sse        intel   + amd
  ; bit 23 edx = mmx        intel   + amd

    LOCAL ecx_  :DWORD
    LOCAL edx_  :DWORD
    LOCAL rval  :DWORD

    push esi
    mov esi, pStruct

    mov eax, 1
    cpuid

    mov ecx_, ecx                                   ; store ECX results in variable
    mov edx_, edx                                   ; store EDX results in variable

    mov eax, ecx_
    and eax, 00000000000100000000000000000000b      ; test bit 20 (INTEL sse4.2)
    ror eax, 20

    .if eax == 1
      mov (X86ST PTR [esi]).sse42, 1
    .else
      mov (X86ST PTR [esi]).sse42, 0
    .endif

    mov eax, ecx_
    and eax, 00000000000010000000000000000000b      ; test bit 19 (INTEL sse4.1)
    ror eax, 19

    .if eax == 1
      mov (X86ST PTR [esi]).sse41, 1
    .else
      mov (X86ST PTR [esi]).sse41, 0
    .endif

    mov eax, ecx_
    and eax, 00000000000000000000000000000001b      ; test bit 0 (INTEL sse3)

    .if eax == 1
      mov (X86ST PTR [esi]).sse3, 1
    .else
      mov (X86ST PTR [esi]).sse3, 0
    .endif

    mov eax, edx_
    and eax, 00000100000000000000000000000000b      ; test bit 26 (INTEL sse2)
    ror eax, 26

    .if eax == 1
      mov (X86ST PTR [esi]).sse2, 1
    .else
      mov (X86ST PTR [esi]).sse2, 0
    .endif

    mov eax, edx_
    and eax, 00000010000000000000000000000000b      ; test bit 25 (INTEL sse)
    ror eax, 25

    .if eax == 1
      mov (X86ST PTR [esi]).sse, 1
    .else
      mov (X86ST PTR [esi]).sse, 0
    .endif

    mov eax, edx_
    and eax, 00000000100000000000000000000000b      ; test bit 23 (INTEL mmx)
    ror eax, 23

    .if eax == 1
      mov (X86ST PTR [esi]).mmx, 1
    .else
      mov (X86ST PTR [esi]).mmx, 0
    .endif

    pop esi

    ret

get_x86_instruction_sets endp

; 

end
