; 
;                               Build this project with MAKEIT.BAT
; 

    include \masm32\include\masm32rt.inc                    ; include the MASM32 runtime library

    .686p                                                   ; 686 privileged instructions
    .MMX                                                    ; multimedia extensions
    .XMM                                                    ; extended multimedia extensions

    include intelmmi.inc
    include cpuid_lib\cpuid.inc
    includelib cpuid_lib\cpuid.lib

; 

    .data?
      bFlag dd ?                                            ; flag for processor brand

    .code                                                   ; start the code section of the application

start:                                                      ; the application entry point
    hInstance cgv(GetModuleHandle, NULL)                    ; create GLOBAL instance handle
    invoke DialogBoxParam,hInstance,1000,0,ADDR WndProc,0   ; Call the dialog box from the resource file
    invoke ExitProcess,eax                                  ; terminate the current running process

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL icce       :INITCOMMONCONTROLSEX
    LOCAL pBuffer    :DWORD
    LOCAL buffer[128]:BYTE
    LOCAL x86        :X86ST
    LOCAL hFile      :DWORD

  ; --------------------------------------
  ; comment out the styles you don't need.
  ; --------------------------------------
    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
    xor eax, eax                                            ; set EAX to zero
    or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
    or eax, ICC_BAR_CLASSES                                 ; comment out the rest
    or eax, ICC_COOL_CLASSES
    or eax, ICC_DATE_CLASSES
    or eax, ICC_HOTKEY_CLASS
    or eax, ICC_INTERNET_CLASSES
    or eax, ICC_LISTVIEW_CLASSES
    or eax, ICC_PAGESCROLLER_CLASS
    or eax, ICC_PROGRESS_CLASS
    or eax, ICC_TAB_CLASSES
    or eax, ICC_TREEVIEW_CLASSES
    or eax, ICC_UPDOWN_CLASS
    or eax, ICC_USEREX_CLASSES
    or eax, ICC_WIN95_CLASSES
    mov icce.dwICC, eax
    invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library
  ; --------------------------------------

    switch uMsg
      case WM_INITDIALOG
        GLOBAL hWnd dd ?                                    ; create a GLOBAL handle for the main window
        m2m hWnd, hWin                                      ; Copy hWin to GLOBAL variable
        fn SendMessage,hWin,WM_SETTEXT,0,"Detect Intel Multimedia Instruction Sets"
        invoke SendMessage,hWin,WM_SETICON,1,rv(LoadIcon,hInstance,1)

      ; --------------------------------------------------
      ; NOTE : cgv (create global value) is a MACRO that
      ; creates a GLOBAL scope value in the .DATA? section
      ; of this executable file. Do NOT create a LOCAL or
      ; GLOBAL value of the same name or you will get
      ; duplicate errors. Also note that each name must be
      ; unique to avoid duplicate errors.
      ; --------------------------------------------------
        hButton1 cgv(GetDlgItem,hWin,1001)

        hStatic1 cgv(GetDlgItem,hWin,1002)
        hStatic2 cgv(GetDlgItem,hWin,1003)
        hStatic3 cgv(GetDlgItem,hWin,1004)
        hStatic4 cgv(GetDlgItem,hWin,1005)
        hStatic5 cgv(GetDlgItem,hWin,1006)
        hStatic6 cgv(GetDlgItem,hWin,1007)
        hStatic7 cgv(GetDlgItem,hWin,1008)
        hStatic8 cgv(GetDlgItem,hWin,1009)
        hStatic9 cgv(GetDlgItem,hWin,1010)
        hStatic10 cgv(GetDlgItem,hWin,1011)
        hStatic11 cgv(GetDlgItem,hWin,1012)
        hStatic12 cgv(GetDlgItem,hWin,1013)
        hStatic13 cgv(GetDlgItem,hWin,1014)
        hStatic14 cgv(GetDlgItem,hWin,1015)
        hStatic15 cgv(GetDlgItem,hWin,1016)
        hStatic16 cgv(GetDlgItem,hWin,1017)
        hStatic17 cgv(GetDlgItem,hWin,1018)
        hStatic18 cgv(GetDlgItem,hWin,1019)
        hStatic19 cgv(GetDlgItem,hWin,1020)
        hStatic20 cgv(GetDlgItem,hWin,1021)
        hStatic21 cgv(GetDlgItem,hWin,1022)
        hStatic22 cgv(GetDlgItem,hWin,1023)
        hIcon     cgv(GetDlgItem,hWin,1024)
        hVendor   cgv(GetDlgItem,hWin,1025)
        hProcessor cgv(GetDlgItem,hWin,1026)

        hLog      cgv(GetDlgItem,hWin,1027)


        invoke PostMessage,hWin,WM_COMMAND,1000,0

        return 1

      case WM_COMMAND
        switch wParam

          case 1027     ; ----------------------------------- create the log file
            mov hFile, fcreate("result.txt")
            mov pBuffer, ptr$(buffer)

            invoke GetWindowText,hVendor,pBuffer,128
            fprintc hFile,"Vendor String = "
            fprint hFile, pBuffer

            invoke GetWindowText,hProcessor,pBuffer,128
            fprintc hFile,"CPU String    = "
            fprint hFile, pBuffer

            invoke GetWindowText,hStatic14,pBuffer,128
            fprintc hFile,"\nSSE4.2 "
            fprint hFile, pBuffer

            invoke GetWindowText,hStatic15,pBuffer,128
            fprintc hFile,"SSE4.1 "
            fprint hFile, pBuffer

            invoke GetWindowText,hStatic16,pBuffer,128
            fprintc hFile,"SSE3   "
            fprint hFile, pBuffer

            invoke GetWindowText,hStatic17,pBuffer,128
            fprintc hFile,"SSE2   "
            fprint hFile, pBuffer

            invoke GetWindowText,hStatic18,pBuffer,128
            fprintc hFile,"SSE    "
            fprint hFile, pBuffer

            invoke GetWindowText,hStatic21,pBuffer,128
            fprintc hFile,"MMX    "
            fprint hFile, pBuffer

            fclose hFile
            invoke EnableWindow,hLog,FALSE
            fn MessageBox,hWin,"File 'result.txt' written to disk","Done",MB_OK

          case 1000     ; ----------------------------------- this is run at startup
            cmp rv(is_cpuid), 0
            jne @F
            fn MessageBox,hWin,"CPUID is not supported on this processor","Sorry ....",MB_OK
            invoke EnableWindow,hLog,FALSE
            ret
          @@:

        ; -------------------
        ; load the Intel logo
        ; -------------------
          hImg cgv(LoadImage,hInstance,50,IMAGE_BITMAP,0,0,LR_DEFAULTSIZE or LR_LOADTRANSPARENT)
          invoke SendMessage,hIcon,STM_SETIMAGE,IMAGE_BITMAP,hImg

          mov pBuffer, ptr$(buffer)                     ; get pointer to buffer
          invoke Get_Brand_String,pBuffer

          switch$ pBuffer
            case$ "GenuineIntel"
              invoke SetWindowText,hVendor,pBuffer
            else$
              fn SetWindowText,hVendor," Non Intel, results may not be valid for this processor."
          endsw$

          invoke get_cpu_id_string,pBuffer
          mov pBuffer, rv(szMonoSpace,pBuffer)          ; clean up any formatting mess.
          invoke SetWindowText,hProcessor,pBuffer

          invoke get_x86_instruction_sets,ADDR x86

          .if x86.sse42 == 1
            fn SetWindowText,hStatic14,"    YES"
          .else
            fn SetWindowText,hStatic14,"    NO"
          .endif

          .if x86.sse41 == 1
            fn SetWindowText,hStatic15,"    YES"
          .else
            fn SetWindowText,hStatic15,"    NO"
          .endif

          .if x86.sse3 == 1
            fn SetWindowText,hStatic16,"    YES"
          .else
            fn SetWindowText,hStatic16,"    NO"
          .endif

          .if x86.sse2 == 1
            fn SetWindowText,hStatic17,"    YES"
          .else
            fn SetWindowText,hStatic17,"    NO"
          .endif

          .if x86.sse == 1
            fn SetWindowText,hStatic18,"    YES"
          .else
            fn SetWindowText,hStatic18,"    NO"
          .endif

          .if x86.mmx == 1
            fn SetWindowText,hStatic21,"    YES"
          .else
            fn SetWindowText,hStatic21,"    NO"
          .endif

          case 1001
            jmp exit_dialog

        endsw

      case WM_CLOSE
        exit_dialog:
        invoke EndDialog,hWin,0

    endsw

    return 0

WndProc endp

; 

end start

